#ifndef SIPL_H
#define SIPL_H
/*
 * SIPL C Interface Header
 *
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>



struct img{
    int row;
    int col;
    unsigned char *r;
    unsigned char *g;
    unsigned char *b; 
} ;


struct matrix{
	int row;
	int col;
	float *data;
} ;

int imgread(const char*filename, struct img * img1);
int imgwrite(struct img *mat, int fmt, const char *filename);
int changeGrey(struct img* image);
int rotateImage(struct img* image);
int flipImage(struct img* image, int n);
int kernel(struct matrix* mat, const char* str);
int convImg(struct img *image, struct matrix *mat);
struct img* elementMul(struct img *img1, float num );
struct img* elementMinus(struct img *img1, int num );
struct img* elementAdd(struct img *img1, int num );
struct img* imgAdd(struct img *img1, struct img *img2 );
struct img* imgCopy(struct img * img1);


#endif
