Image resize (Image img, float scaleX, float scaleY){
    float cols;
    float rows;
    float bp_row;
    float bp_col;
    int i;
    int j;
    float delx;
    float dely;
    Pixel tmp;
    int tmp2;
    int indexy;
    int indexx;
    Image res;

    cols =  img.width * scaleX;
    rows =  img.height * scaleY;

    res = imgCreate(float2int(rows), float2int(cols));   

    for(i = 0; i < float2int(rows); i = i + 1){
        for(j = 0; j < float2int(cols); j = j + 1){
            bp_row =  i / scaleY;
            bp_col =  j / scaleX;
            indexx = float2int(bp_col);
            indexy = float2int(bp_row);

            delx = bp_col -  indexx;
            dely = bp_row -  indexy; 

            tmp =  img[indexy][indexx]["a"] * (1.0 - delx) * (1.0 - dely);
            tmp = tmp +  img[indexy + 1][indexx]["a"] * delx * ( 1.0 - dely) ;
            tmp = tmp +  img[indexy + 1][indexx + 1]["a"] * dely * delx;
            tmp = tmp +  img[indexy][indexx + 1]["a"] * (1.0 - delx) * dely;
            res[i][j]["a"] = tmp;

        }
    }

    return res;
}

Matrix gaussian(int size, float sigma){
    
    int i;  
    int j;
    float e;
    float tmp;
    Matrix gauss;
    float sum;

    gauss = matCreate(size, size);
    e = 2.718281828459;
    for(i = 0; i < size; i = i + 1){
        for(j = 0; j < size; j = j + 1){
            tmp = 0 - (power((i - (size - 1)/2.0), 2.0) + power((j - (size - 1)/2.0), 2.0))/(2.0 * sigma * sigma);
            gauss[i][j] = power(e, tmp);
            sum = sum + gauss[i][j];
        }
    }

    for(i = 0; i < size; i = i + 1){
        for(j = 0; j < size; j = j + 1){
            gauss[i][j] = gauss[i][j]/sum;
        }
    }
    return gauss;
}

Image sliceImg(Image img, int left, int up, int cols, int rows) {
    int i;
    int j;
    int down;
    int right;
    Image res;
    down = up + rows;
    right = left + cols;

    if(down >= img.height){
        down = img.height;
    }
    if(right >= img.width){
        right = img.width;
    }

    res = imgCreate(down - up, right - left);
    
    for(i = up; i < down; i = i + 1){
        for(j = left; j < right; j = j + 1){
            res[i - up][j - left]["r"] = img[i][j]["r"];
            res[i - up][j - left]["g"] = img[i][j]["g"];
            res[i - up][j - left]["b"] = img[i][j]["b"];
        }
    }        
    return res;
}

Matrix sliceMat(Matrix mat, int left, int up, int cols, int rows) {
    int i;
    int j;
    int down;
    int right;
    Matrix res;
    down = up + rows;
    right = left + cols;

    if(down >= mat.height){
        down = mat.height;
    }
    if(right >= mat.width){
        right = mat.width;
    }

    res = matCreate(down - up, right - left);
    
    for(i = up; i < down; i = i + 1){
        for(j = left; j < right; j = j + 1){
            res[i - up][j - left] = mat[i][j];
        }
    }        
    return res;
}

